//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "polent.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void polinuloe(polime& p)
{p.ult=-1;}

bool esnuloe(polime p)
{return (p.ult==-1);}

void busca_expe(monoe v[Ne],int x,int c, int f, bool& existe,int& pos)
{
  int m;
 if (c>f)
  {existe=false;
   pos=c;
  }
 else
  {m = (c+f)/2;
   if (v[m].exp==x)
    {existe=true;
     pos=m;
    }
   else if (v[m].exp<x)
    {busca_expe(v,x,m+1,f,existe,pos);}
   else {busca_expe(v,x,c,m-1,existe,pos);}
  }
}

void desplaza_dere(monoe v[Ne],int a,int b)
{for (int i=b;i>=a;i--) {v[i+1]=v[i];};}

void desplaza_izqe(monoe v[Ne],int a,int b)
{for (int i=a;i<=b;i++) {v[i-1]=v[i];};}

void suma_monoe(int c,int i,polime& p)
{
 bool existe;
 int pos;
 if (!(c==0))
  {busca_expe(p.monoms,i,0,p.ult,existe,pos);
   if (existe)
    {p.monoms[pos].coef=p.monoms[pos].coef + c;
     if (p.monoms[pos].coef==0)
      {desplaza_izqe(p.monoms,pos,p.ult);
       p.ult=p.ult-1;
      };
    }
   else
    { if (p.ult==Ne-1) {throw Exception("Overflow");}
      else
       {desplaza_dere(p.monoms,pos,p.ult);
        p.monoms[pos].coef=c;
        p.monoms[pos].exp=i;
        p.ult=p.ult+1;
       }
    };
   }
}

void sumae(polime& p,polime q)
{for (int i=0;i<=p.ult;i++)
  {suma_monoe(q.monoms[i].coef,q.monoms[i].exp,p);}
}


void copiae(polime r,polime& p)
{
 polinuloe(p);
 p.ult=r.ult;
 for (int i=0;i<=p.ult;i++)
  {p.monoms[i].coef=r.monoms[i].coef;
   p.monoms[i].exp=r.monoms[i].exp;
  }
}

void multe(polime& p,polime q)
{polime r;
 polinuloe(r);
 for (int i=0;i<=q.ult;i++)
  for (int j=0;j<=p.ult;j++)
   {suma_monoe(q.monoms[i].coef*p.monoms[j].coef,
              q.monoms[i].exp+p.monoms[j].exp,r);
   };
 copiae(r,p);
}

int coefe(int i,polime p)
{int c;
 bool existe;
 int pos;
 busca_expe(p.monoms,i,0,p.ult,existe,pos);
 if (existe) {c=p.monoms[pos].coef;}
 else {c=0;};
 return c;
}

int gradoe(polime p)
{int g;
 if (!(p.ult==-1)) {g=p.monoms[p.ult].exp;}
 else {g=0;};
 return g;
}
 int potencia(int b,int exp)
{int p;
 if (exp==0) {p=1;}
 else if (exp>0) {p=b*potencia(b,exp-1);}
 else {throw Exception("Exponente negativo");}
 return p;
}

int evale(polime p,int x)
{int w=0;
 for (int i=0;i<=p.ult;i++)
  {w=w+p.monoms[i].coef*potencia(x,p.monoms[i].exp);};
 return w;
}
